﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Xml;

namespace LinkSmartForDummies_2
{
    class Program
    {
        static void Main(string[] args)
        {//This tutorial illustrates interaction and control of several IoTResources
            SetHueCenterBlue();
            TurnOnDiscoBall();
            TurnOffDiscoBall();
            PulseHues();
            StartParty();
        }

        public static void SetHueCenterBlue()
        {
            //Create REST-endpoint to Hue

            string hueexpr = "http://linksmart.cnet.se:44441/IoTresources/HueSpotCenter/services/multicolordimmer/actions/SetRGBColor?blue=255";

            XmlDocument myDoc = new XmlDocument();

            myDoc.Load(hueexpr);//This invokes the action and parses the Xml returned as an answer
        }



        public static void TurnOnDiscoBall()
        {
            //Create REST-endpoint to TurnOn

            string turnonexpr = "http://linksmart.cnet.se:44441/IoTresources/DiscoBall/services/switch/actions/TurnOn";

            XmlDocument myDoc = new XmlDocument();

            myDoc.Load(turnonexpr);//This invokes the action and parses the Xml returned as an answer

        }

        public static void TurnOffDiscoBall()
        {
            //Create REST-endpoint to TurnOn

            string turnonexpr = "http://linksmart.cnet.se:44441/IoTresources/DiscoBall/services/switch/actions/TurnOff";

            XmlDocument myDoc = new XmlDocument();

            myDoc.Load(turnonexpr);//This invokes the action and parses the Xml returned as an answer

        }

        public static void PulseHues()
        {
            //Create REST-endpoint to Hue

            string hueexpr = "http://linksmart.cnet.se:44441/IoTresources/HueSpotCenter/services/multicolordimmer/actions/SetRGBColor?blue=255";

            XmlDocument myDoc = new XmlDocument();

            myDoc.Load(hueexpr);//This will set color to blue on center spot

            Thread.Sleep(2000);//Now wait 2 seconds
            
            hueexpr = "http://linksmart.cnet.se:44441/IoTresources/HueSpotCenter/services/multicolordimmer/actions/TurnOff";
            myDoc.Load(hueexpr);//Turn the center spot off

            hueexpr = "http://linksmart.cnet.se:44441/IoTresources/HueSpotLeft/services/multicolordimmer/actions/SetRGBColor?red=255";
            myDoc.Load(hueexpr);//This will set color to red on left spot
            Thread.Sleep(2000);//Now wait 2 seconds

            hueexpr = "http://linksmart.cnet.se:44441/IoTresources/HueSpotLeft/services/multicolordimmer/actions/TurnOff";
            myDoc.Load(hueexpr);//Turn the left spot off

            hueexpr = "http://linksmart.cnet.se:44441/IoTresources/HueSpotRight/services/multicolordimmer/actions/SetRGBColor?green=255";
            myDoc.Load(hueexpr);//This will set color to green on right spot
            Thread.Sleep(2000);//Now wait 2 seconds

            hueexpr = "http://linksmart.cnet.se:44441/IoTresources/HueSpotRight/services/multicolordimmer/actions/TurnOff";
            myDoc.Load(hueexpr);//Turn the right spot off
        }

        public static void StartParty()
        {
            TurnOnDiscoBall();
            PulseHues();
        }
    }
}
