﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml;

namespace LinkSmartForDummies_3
{
    class Program
    {
        static string huespotName; // HueSpotLeft, HueSpotCenter, HueSpotRight

        //This tutorial illustrates basic IoTResource sensor value retrival and control using the REST-based API for IoTResources
        static void Main(string[] args)
        {
            int co2Value = GetCO2Level();
            huespotName = "HueSpotCenter";
            if (co2Value < 800)
                SetRGBColor(0, 255, 0);
            else if (co2Value >= 800 && co2Value < 1200)
                SetRGBColor(255, 255, 0);
            else if (co2Value >= 1200)
                SetRGBColor(255, 0, 0);

            TurnOff();
        }

        public static int GetCO2Level()
        {
            //Create REST-endpoint to fetch CO2 level
            string expression = "http://linksmart.cnet.se:44441/IoTresources/SR04CO2/services/IoTObservation/statevariables/CO2Level";
            XmlDocument myDoc = new XmlDocument();
            myDoc.Load(expression);

            int result = -1;
            XmlNode theNode = myDoc.SelectSingleNode("//*[name()='IoTValue']");
            if (theNode != null)
            {
                result = int.Parse(theNode.InnerText);
            }
            return result;
        }

        public static void TurnOn()
        {
            //Create REST-endpoint to TurnOn
            string expression = string.Format("http://linksmart.cnet.se:44441/IoTresources/{0}/services/multicolordimmer/actions/TurnOn", huespotName);
            XmlDocument myDoc = new XmlDocument();
            myDoc.Load(expression);
        }

        public static void TurnOff()
        {
            //Create REST-endpoint to TurnOff
            string expression = string.Format("http://linksmart.cnet.se:44441/IoTresources/{0}/services/multicolordimmer/actions/TurnOff", huespotName);
            XmlDocument myDoc = new XmlDocument();
            myDoc.Load(expression);
        }

        public static void SetRGBColor(byte red, byte green, byte blue)
        {
            //Create REST-endpoint to set RGB color
            string expression = string.Format("http://linksmart.cnet.se:44441/IoTresources/{0}/services/multicolordimmer/actions/SetRGBColor?red={1}&green={2}&blue={3}",
                                               huespotName, red, green, blue);
            XmlDocument myDoc = new XmlDocument();
            myDoc.Load(expression);
        }
    }
}
